<template>
  <q-card
    :square="!isDesktopPlatform"
  >
    <q-card-section>
      <div
        v-if="loading"
        class="column flex-center"
      >
        <q-spinner-dots
          color="primary"
          size="24px"
        />
      </div>

      <NitrogenLimitationNoResult v-else-if="error" />

      <template v-else-if="nitrogenLimitations">
        <div
          v-if="showInputParametersHint"
          class="text-caption text-grey-7"
        >
          <translate>Fill in the following parameters to check the nitrogen limitations applicable to your crop.</translate>
        </div>

        <div
          v-if="missingPlotPlantSpecies"
          class="text-body2 text-grey-7 q-mt-md"
        >
          <translate>A crop must be assigned to the plot</translate>
          <a
            v-if="plotPlantVarietyCanBeAdded"
            @click="onEditCrop"
          >
            <span class="q-ml-xs">
              <translate>(assign a crop)</translate>
            </span>
          </a>.
        </div>

        <div
          v-if="missingPlotCropYield"
          class="text-body2 text-grey-7 q-mt-md"
        >
          <translate>The crop yield must be set for the plot</translate>
          <a
            v-if="plotPlantVarietyCanBeAdded"
            @click="onEditCrop"
          >
            <span class="q-ml-xs">
              <translate>(set the crop yield)</translate>
            </span>
          </a>.
        </div>

        <template v-if="nitrogenLimitationParams && nitrogenLimitationParams.length">
          <div
            v-for="param in nitrogenLimitationParams"
            :key="param.id"
            class="text-body2 text-grey-7 q-mt-md q-mb-sm"
          >
            <q-select
              v-model="inputParams[param.id]"
              :options="param.choices"
              :label="param.label"
              option-value="id"
              option-label="label"
              filled
              hide-bottom-space
            />
          </div>
        </template>

        <q-list
          v-if="nitrogenLimits && nitrogenLimits.length"
          class="q-mt-md"
        >
          <NitrogenLimitListItem
            v-for="nitrogenLimit in nitrogenLimits"
            :key="nitrogenLimit.id"
            :value="nitrogenLimit.value"
            :unit="nitrogenLimit.unit"
            :comment="nitrogenLimit.comment"
          />
        </q-list>

        <q-list
          v-if="nitrogenWarnings && nitrogenWarnings.length"
          class="q-mt-sm"
        >
          <NitrogenWarningListItem
            v-for="nitrogenWarning in nitrogenWarnings"
            :key="nitrogenWarning.id"
            :title="nitrogenWarning.title"
            :content="nitrogenWarning.content"
            :url="nitrogenWarning.url"
          />
        </q-list>

        <NitrogenLimitationNoResult
          v-if="noResult"
          :plot-plant-variety="plotPlantVariety"
          :is-in-n-v-z="isInNVZ"
          :class="{ 'q-mt-md': hasInputParams }"
        />
      </template>
    </q-card-section>
  </q-card>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import featureFlags from 'src/services/feature-flags'
import queryNitrogenLimitations from 'src/pages/holding-campaign/plot/graphql/queryNitrogenLimitations'
import queryPlotCrops from 'src/pages/holding-campaign/plot/graphql/queryPlotCrops'
import queryPlotConstraints from 'src/pages/holding-campaign/plot/graphql/queryPlotConstraints'
import NitrogenLimitListItem from 'src/pages/holding-campaign/plot/components/NitrogenLimitListItem'
import NitrogenWarningListItem from 'src/pages/holding-campaign/plot/components/NitrogenWarningListItem'
import NitrogenLimitationNoResult from 'src/pages/holding-campaign/plot/components/NitrogenLimitationNoResult'

export default {
  name: 'PlotNitrogenLimitationsCard',
  components: {
    NitrogenLimitListItem,
    NitrogenWarningListItem,
    NitrogenLimitationNoResult
  },
  mixins: [
    PlatformMixin
  ],
  props: {
    plotId: {
      type: Number,
      required: true
    }
  },
  data () {
    return {
      inputParams: {},
      error: null
    }
  },
  computed: {
    loading () {
      return (!this.nitrogenLimitations && this.$apollo.queries.nitrogenLimitations.loading) ||
        (!this.plot && this.$apollo.queries.plot.loading) ||
        (!this.plotConstraints && this.$apollo.queries.plotConstraints.loading)
    },
    plotPlantVarietyCanBeAdded () {
      return featureFlags.plotPlantVarietyCanBeAdded()
    },
    missingPlotPlantSpecies () {
      return this.nitrogenLimitations?.missing_base_params?.includes('plot_plant_species_missing')
    },
    missingPlotCropYield () {
      return this.nitrogenLimitations?.missing_base_params?.includes('plot_crop_yield_missing')
    },
    nitrogenLimitationParams () {
      return this.nitrogenLimitations?.params || []
    },
    nitrogenLimitationMissingParams () {
      return this.nitrogenLimitationParams.filter(param => param.value == null)
    },
    nitrogenLimits () {
      return this.nitrogenLimitations?.nitrogen_limits || []
    },
    nitrogenWarnings () {
      return this.nitrogenLimitations?.warnings || []
    },
    nitrogenInputParams () {
      const formattedInputParams = {}
      for (const paramId in this.inputParams) {
        if (this.inputParams[paramId]) {
          formattedInputParams[paramId] = this.inputParams[paramId].id
        }
      }
      return JSON.stringify(formattedInputParams)
    },
    noResult () {
      return !this.missingPlotPlantSpecies && !this.missingPlotCropYield && !this.nitrogenLimitationMissingParams?.length && !this.nitrogenLimits?.length && !this.nitrogenWarnings?.length
    },
    hasInputParams () {
      return Boolean(Object.entries(this.inputParams).length)
    },
    showInputParametersHint () {
      return this.missingPlotPlantSpecies || this.missingPlotCropYield || this.nitrogenLimitationParams?.length
    },
    plotPlantVariety () {
      return this.plot?.plot_plant_varieties?.[0]
    },
    cropId () {
      // only the first crop is taken into account by the nitrage limit service
      return this.plot?.plot_plant_varieties?.[0]?.id
    },
    isInNVZ () {
      return this.plotConstraints?.filter(constraint => constraint.name === 'management_restriction_or_regulation_zone').length > 0
    }
  },
  apollo: {
    nitrogenLimitations: {
      query: queryNitrogenLimitations,
      fetchPolicy: 'network-only',
      variables () {
        return {
          input: {
            plot_id: this.plotId,
            params: this.nitrogenInputParams
          }
        }
      },
      update: data => data.nitrogen_limitation,
      result ({ error }) {
        if (error) {
          this.error = error
        } else {
          this.error = null
          const updatedInputParams = {}
          for (const param of this.nitrogenLimitationParams) {
            updatedInputParams[param.id] = param.choices.find(choice => choice.id === param.value) || null
          }
          this.inputParams = updatedInputParams
        }
      }
    },
    plot: {
      query: queryPlotCrops,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          plotId: this.plotId
        }
      }
    },
    plotConstraints: {
      query: queryPlotConstraints,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          plotId: this.plotId
        }
      }
    }
  },
  methods: {
    onEditCrop () {
      this.$router.push({ name: 'plotCropEdit', params: { idPlot: this.plotId, idCrop: this.cropId } })
    }
  }
}
</script>
